#pragma once

#include "klibrary.h"


class App
{
public:
	kl::Window window{ "Pressure Simulator", { 1600, 900 } };
	kl::GPU gpu{ static_cast<HWND>(window) };

	kl::Image simulation_image;
	kl::dx::ShaderView simulation_view;

	float dpi_scaling = 1.0f;
	float current_pressure = 0.0f;

	std::array<std::pair<float, float>, 10> pressure_data;

	App();
	bool update();

private:
	void render_ui();
	void load_custom_fonts();
	void load_custom_theme();
};
